#!/opt/bin/php
<?php
/* SVN FILE: $Id: hp_data.com 510 2014-10-18 12:41:41Z anders $
* Project Name : ThermIQ
* @version $Revision: 510 $ 
* @lastrevision $Date: 2014-10-18 14:41:41 +0200 (lör, 18 okt 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-10-18 14:41:41 +0200 (lör, 18 okt 2014) $
*/
if (!isset($settings)) {
	include("common_settings");
}


    function prune_argv($options_array)
    {
        foreach( $options_array as $o => $a )
        {
            // Look for all occurrences of option in argv and remove if found :
            // ----------------------------------------------------------------
            // Look for occurrences of -o (simple option with no value) or -o<val> (no space in between):
            while($k=array_search("-".$o.$a,$GLOBALS['argv']))
            {    // If found remove from argv:
                if($k)
                    unset($GLOBALS['argv'][$k]);
            }
            // Look for remaining occurrences of -o <val> (space in between):
            while($k=array_search("-".$o,$GLOBALS['argv']))
            {    // If found remove both option and value from argv:
                if($k)
                {    unset($GLOBALS['argv'][$k]);
                    unset($GLOBALS['argv'][$k+1]);
                }
            }
        }
        // Reindex :
        $GLOBALS['argv']=array_merge($GLOBALS['argv']);
        $GLOBALS['argc']=count($GLOBALS['argv']);
    }
    
    function print_usage() {
			printf("\nhpdata.com
			-v		verbose, 
			-r 		do a read
			-w    do a write
			-g    get time
			-s    set time
			-pport	  Communicate with port (-pCOMx: or -p/dev/ttyUSB0 etc )
			-h		is help\n");
    }


$options=getopt('rwgsvhp:');
// Remove found options leaving the rest in argv array
prune_argv($options);
  //echo ">\n";
  //print_r($argv);
  //echo "<\n";
  
if(isset($options["h"]) || isset($options["?"])) {
print_usage();
exit;
}

$verbose=false;
 if (isset($options["v"])) {
$verbose=TRUE;
	echo("hp_data.com is running\n");
} else {
	//error_reporting(0);
}
 
  
  if (isset($options["p"])) {
    $comstr = explode(':',$options["p"]);
    if (strlen($comstr[0])>0 ) {
       $device=$comstr[0];
       if ($verbose) echo("Using port: ".$device."\n");
    } else {
       if ($verbose) exit("\nNot enough parameters to hp_data.com: ".$argv."\n"); else exit();
    }
   }

   // This is ugly - TODO: Find a general solution for sake of portability
   // Changed timeout to 10 sek in order to handle new bootloaders
   // Sum of sleep and TO should be greater than 12 sek (for fw>4.30 this could be changed to 2 sek)
   if (strstr(php_uname(),'Linux')) exec("$sttypath -F $device clocal cread -parenb -brkint -icrnl -imaxbel -opost -isig -icanon -iexten -echo time 20 min 0 9600 >>/dev/null 2>&1");

   
   if (isset($options["r"])) {
  	if ((($argc == 3) && (is_numeric($argv[1])) && (is_numeric($argv[2])))) {
     $startadr = $argv[1];
     $length =  $argv[2];
     $endadr = $startadr + $length -1;
     if (($startadr <= $endadr) && ($startadr <128) && ($endadr <128)) {
     		$a=sprintf("%02X",$startadr);
     		$b=sprintf("%02X",$endadr);
				if (strstr(php_uname(),'Linux')) exec("$sttypath -F $device clocal cread -parenb -brkint -icrnl -imaxbel -opost -isig -icanon -iexten -echo time 8 min 0 9600 >>/dev/null 2>&1");
				$fp = fopen($device,'r+b');
				if (!$fp) {
					echo "Unable to open $device\n";
				} else {
				fwrite($fp,"ati\r");
				while (!feof($fp)) {		// Purge input buffer
		       	 $row = fgets($fp,1024);
		       	 if ($verbose) echo $row;
		    }
		    fclose($fp);
		   	if (strstr(php_uname(),'Linux')) exec("$sttypath -F $device clocal cread -parenb -brkint -icrnl -imaxbel -opost -isig -icanon -iexten -echo time 25 min 0 9600 >>/dev/null 2>&1"); // Set to 20 with newest fw
		     $fp = fopen($device,'r+b');
		      if (!$fp) {
		    		echo "Unable to open $device\n";
					} else {
						$time=date('U');
						fwrite($fp,"atr$a$b\r");
						//sleep(4); //Can be removed with newest fw
						$registers=array();
						while (!feof($fp)) {
							$row = fgets($fp,1024);
							if ($row!==FALSE) {
								if ($verbose) echo $row;
								$x = explode('=',rtrim($row));
								if (isset($x[1])) {
									$res = hexdec('0x'.$x[1]);
									 if ($res > 32767) $res=$res-65536;
									$reg = hexdec('0x'.$x[0]);
									$registers[$reg]=$res;
									//echo("insert into tempdata values ($time, $reg, $res)\n");
									//$tempdb->exec("insert or REPLACE into tempdata (TIME, REGNUM,REGVALUE) values ($time, $reg, $res)");
								}
							}
						}
						ksort($registers,SORT_NUMERIC);
						echo "\n";
						echo http_build_query($registers,'',"&")."&\n";
						fclose($fp);
					}
				}
		  }
     exit;
   } 
   print_usage();
   exit;
   } else

   if (isset($options["w"])) {
  	 if ((($argc == 3) && (is_numeric($argv[1])) && (is_numeric($argv[2])))) {
        $startadr = $argv[1] + 128;
        $data = (($argv[2] < 0) ? $argv[2] + 65536 : $argv[2]);
        if (($startadr <= 255) && ($startadr >= 0) && ($data < 65536) && ($data >= 0)) {
           $datahi=($data & 65280) >> 8;
           $datalo=($data & 255);
           $a=sprintf("%02X",$startadr);
			     $b=sprintf("%02X",$datalo);
			     $c=sprintf("%02X",$datahi);
			     $fp=fopen($device,'r+b');
			     if (!$fp) {
		    	    echo "Unable to open $device\n";
					 } else {
			        fwrite($fp,"atw$a$c$b\r");
			        sleep(15);
				       while (!feof($fp)) {
				       	 $row = fgets($fp,1024);
				       	 if (!feof($fp)) {
				       	 		$last=$row;
				       	 }
				       }
			        if (!strstr($last,'OK')) if ($verbose) echo("ERROR\n"); 
			        fclose($fp);
		       }
     			 exit;
     		}
     }
   print_usage();
   exit;
	 } else 
	
	if (isset($options["g"])) {
		if ($argc == 1) {
			$fp = fopen($device,'r+b');
			if (!$fp) {
				echo "Unable to open $device\n";
			} else {
				fwrite($fp,"attg\r");
				sleep(1);
				$x = '';
				while (!feof($fp)) {
					$row = fgets($fp,1024);
					if (!feof($fp)) {
						$last=$row;
						if (strstr($row,':')) $x = $row;
					}
				}
				if (!strstr($last,'OK')) if ($verbose) echo("ERROR\n");
				fclose($fp);
				echo $x;
			}
			exit;
		}
   	print_usage();
   	exit;
  } else

   if (isset($options["s"])) {
       if ($argc == 1) {
		      $fp=fopen($device,'r+b');
		      if (!$fp) {
		    		 echo "Unable to open $device\n";
					} else {
			       $x = date('Ymd H:i:s');
				     fwrite($fp,"atts$x\r");
				     sleep(2);
				     while (!feof($fp)) {
							$row = fgets($fp,1024);
							if (!feof($fp)) {
								$last=$row;
							}
						}
						if (!strstr($last,'OK')) if ($verbose) echo("ERROR\n");
						fclose($fp);
			    }
			   exit;
       }
			 print_usage();
			 exit;    
		} else {
		   print_usage();
		   exit;
}
?>

