<?php
    try
    {
    include_once('../init.php'); 
    } catch (Exception $e) {
		}
?>

<!DOCTYPE html PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>
 <head>
 <meta name="revised" content=\"\$Revision: 482 $" />
  <title>
   ThermIQ installation checks
  </title>
 </head>
 <body>
  <h1>
   ThermIQ installation checks
  </h1>
	Your webserver can serve html<br>	
	And supports the following java versions:<br><span style="color:red">
 
        <script type="text/javascript" src="http://java.com/js/deployJava.js"></script><noscript><strong>Your browser either does not support JavaScript or it is turned off.<br>Without Javascript enabled, ThermIQ-Web will not function correctly</strong></noscript>

        <script type="text/javascript">
            document.write('</span><span style="color:green">'+deployJava.getJREs()); // Show all installed JRE versions.
            document.write('<br>Javascripts seems to be enabled<br></span>');
        </script> 
      </span>
	<hr>
<?php
/* SVN FILE: $Id: check_install.php 482 2014-01-12 15:38:00Z anders $
* Project Name : ThermIQ*
* @version $Revision: 482 $
* @lastrevision $Date: 2014-01-12 16:38:00 +0100 (sön, 12 jan 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-01-12 16:38:00 +0100 (sön, 12 jan 2014) $
*/
    echo "and PHP is working!<br>phpversion() says: ";
    echo phpversion()."<br>\n";
    echo "The machine information is<br><span style=\"color:green\">";
    echo php_uname('a')."</span><br><br>";
    
    if (file_exists_incpath('poller') ) {
			$bin_dir=dirname(realpath(file_exists_incpath('poller')));
		}
		$file_handle = fopen($bin_dir.DIRECTORY_SEPARATOR."..".DIRECTORY_SEPARATOR."..".DIRECTORY_SEPARATOR."RevisionLog.txt", "rb");
    if ($file_handle === false) {
	  	echo '<b>Local release:</b>&nbsp;&nbsp;0 - RevisionLog.txt not found<br>';
      $local_rev="0";
    } else { 
			$lt = fgets($file_handle);
			$local=explode(':',$lt);
		        $local_rev=trim(trim($local[1]));
			echo '<b>Local release:</b>&nbsp;&nbsp;'.$local_rev.'<br>';
			fclose($file_handle);
    }

    
    
    print "Trying to read ../init.php in the following directorys<br>";
    $paths = explode(PATH_SEPARATOR, get_include_path());
    foreach ($paths as $path) {
    	echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;".$path;
    }
    //phpinfo();

	echo "<br>";
    try
    {
    include_once('../init.php'); 
    } catch (Exception $e) {
    	echo '<span style="color:red"><b>Caught exception: '.  $e->getMessage(). " when trying to include ../init.php</b></span><br>";
		}
    function print_r2($val){
        echo '<pre>';
        print_r($val);
        echo  '</pre>';
		}
		
	
    if (isset($settings)) {
    	print "<br>   and can read the init.php configuration file<br><br>";   	
   
    	echo "Checking for ThermIQ configuration and language files <br><pre>";
	$php_scripts=array($opt_path.'Thermiq_Windows.ini',$opt_path.'Thermiq_Linux.ini',$opt_path.'Thermiq_sw.ini',$opt_path.'Thermiq_de.ini',$opt_path.'Thermiq_en.ini',$opt_path.'Thermiq_no.ini',$opt_path.'Thermiq_fi.ini');
		

	foreach ($php_scripts as $script) {
		echo "<pre>".$script." ";
		if (file_exists($script)) {
				echo '=> <span style="color:green"><b>'.realpath(($script))."</span>";
		} else {
			echo '<span style="color:red"><b>is missing</span>';
		}
		echo "<b></pre>";
		
	}
    	echo "<br><b> ";
    	print "This is your settings from ";

    	if (strstr(php_uname('s'),'Linux')) {
				print realpath("/opt/etc/Thermiq_Linux.ini");
				$os=linux;
			}
			else if(strstr(php_uname('s'),'Windows')) {
		    $basedir=substr($_SERVER["PHPRC"],0,strlen($_SERVER["PHPRC"])-4);
				echo realpath($basedir . "/opt/etc/Thermiq_Windows.ini");	
				$os='windows';
			} else {
					echo "<br><b>Unknown OS:</b> assuming Unix-style paths.</br>";
					echo "Update <webroot>/init.php to correct this</br>";
					print realpath("/opt/etc/Thermiq_Linux.ini");	
			}
     	print_r2 ($settings);
    } else {
    	print "   but is not able to read ThermIQ configuration files from:";   	
    }
 
  echo "</b><hr><body>";
 
  if (isset($settings['thermiq']['optional_init']) && ($settings['thermiq']['optional_init']<>'')) {
  	echo "Optional ini settings are read from" . realpath("/opt/etc/Thermiq_".$settings['thermiq']['language'].".ini");
	  echo "</b><br><hr><body>";
	}
  

	if (file_exists(realpath($opt_path.'Thermiq_'.$settings['thermiq']['language'].'.ini'))) {
		echo "Language settings are read from: <b>".realpath($opt_path.'Thermiq_'.$settings['thermiq']['language'].'.ini')."</b><br>";		
		echo "Version: ??";
	} else 
	if ( file_exists_incpath($opt_path.'Thermiq_'.$settings['thermiq']['language'].'.ini')) {
		echo "Language settings are read from: <b>". realpath(file_exists_incpath($opt_path.'Thermiq_'.$settings['thermiq']['language'].'.ini'))."</b><br>";
		echo "Version: ??";
	} else {
		echo("<br><b>Missing or faulty language file: </b>/opt/etc/Thermiq_".$settings['thermiq']['language'].'.ini</br>');
		echo("You can correct this in /opt/etc/Thermiq.ini</b></br>");
	}
	echo "<hr>";
	echo "Checking installed webcontent in ". realpath($_SERVER["DOCUMENT_ROOT"]) . "<br><pre>";
	$php_scripts=array('aggr_day.php','aggr_hour.php','check_install.php','hello_php.php','hp_status.php','hp_write.php',
									'index.php','larmlogg.php','menu_write.php','menus.php','rawdata.php','settings.php','settings_db.php',
									'settings_global.php','settings_logs.php','settings_mail.php',
									'settings_update.php','toplinks.php','img','../php-ofc-library','../init.php');


	foreach ($php_scripts as $script) {
		echo "<pre>".$script." ";
		if (file_exists_incpath($script)) {
				echo '=> <span style="color:green"><b>'.realpath(file_exists_incpath($script))."</span>";
			  if ($os=='linux' && !is_executable (file_exists_incpath($script))) {
					echo '<span style="color:red"><b>&nbsp;&nbsp;&nbsp;BUT is not executable';
					chmod(file_exists_incpath($script),0755);
					if (is_executable (file_exists_incpath($script))) 
					{
						echo '<span style="color:green"><b>&nbsp;&nbsp;&nbsp;Fixed It</span>';
					}
				}
		} else {
			echo '<span style="color:red"><b>is missing in '.realpath($_SERVER["DOCUMENT_ROOT"])."</span>";
		}
		echo "<b></pre>";
		
	}
 

	echo "<hr><br><b>Checking installed scripts in </b>";
	$paths = explode(PATH_SEPARATOR, get_include_path());
    foreach ($paths as $path) {
    	echo "<br>&nbsp;&nbsp;&nbsp;&nbsp;".$path;
    }

	
	$php_scripts=array('alarm_handler','common_settings','dummy_poll','hp_data','load_log','mkdbtemplate','new_db_sqlite','poller','update_client');


	foreach ($php_scripts as $script) {
		echo "<pre>".$script." ";
		if (file_exists_incpath($script) ) {
			echo '=> <span style="color:green"><b>'.realpath(file_exists_incpath($script))."</span>";
			if ($os=='linux' && !is_executable (file_exists_incpath($script))) {
				echo '<span style="color:red"><b>&nbsp;&nbsp;&nbsp;BUT is not executable</span>';
				chmod(file_exists_incpath($script),0755);
				if (is_executable (file_exists_incpath($script))) {
				echo '<span style="color:green"><b>&nbsp;&nbsp;&nbsp;Fixed It</span>';
				}
			}

		} else {
			echo '<span style="color:red"><b>is missing in include path'."</span>";
		}
		echo "<b></pre>";
	}
	
	echo "<br><b>Checking for required directories </b>";
	$php_scripts=array(
	
	'Temporary database path'=>$settings['misc']['tempdir'],
	'Permanent database path'=>$settings['misc']['permdir']);

	foreach ($php_scripts as $script=>$itsPath) {
		echo "<pre>".$script." ";
		if (is_dir($itsPath) ) {
			echo '=> <span style="color:green"><b>'.realpath($itsPath)."</span>";

		} else {
			echo '<span style="color:red"><b>directory is missing: '.realpath($itsPath)."</span>";
			mkdir($itsPath,0777,TRUE);
			if (is_dir($itsPath) ) {
				echo '=> <span style="color:green"><b>Created successfully</span>';
			} else {
				echo '=> <span style="color:red"><b>Failed misserably</span>';
			}
		}

		echo "<b></pre>";
	}
	echo "<hr><br><b>Checking available database handlers (PDO) </b></br>";
	echo "Preferred is 'sqlite' which is PDO for sqlite3, others might work </b></br></br>";

	foreach(PDO::getAvailableDrivers() as $driver)
    {
    	if ($driver=='sqlite') echo '<span style="color:green">'; else echo '<span style="color:orange">';
    	echo $driver.'</span><br />';
    }
 


	echo "<hr><br><b>Checking required utils </b></br>";
	if (strstr(php_uname(),'Linux')) {
		//stty
	echo "Checking for /opt/bin/stty";
	$output='';
	exec("$sttypath -a -F $device",$output);
	echo "\n";
	print_r2( $output);
	$output='';
	echo "Checking for /opt/bin/php";
	exec("ls -la /opt/bin/php",$output);
	echo "\n";
	print_r2( $output);
	$output='';
	  if (strstr(php_uname(),'raspberrypi')) {
// Raspberry
	//php_scriptpath
	if ($settings['misc']['php_scriptpath']<>'/usr/sbin/') {
			echo "<span style=\"color:red\">php_scriptpath not set correctly in /opt/etc/Thermiq_Linux.ini.</span> Should be:\nphp_scriptpath = /usr/sbin/\n\n";
			echo '<a href="/settings_global.php">Fix it here</a>';
			/*exec("chmod a+rw /opt/etc",$output,$err);
			exec("sudo /bin/sed -i 's:^.*php_scriptpath.*:php_scriptpath = /usr/sbin/:' /opt/etc/Thermiq_Linux.ini",$output,$err);
			print_r2( $output);
			print_r2( $err);*/
	}
	$output='';
	//msmtprc
		if ($settings['misc']['mail_rc_file']<>'/etc/msmtprc') {
			echo "<span style=\"color:red\">mail_rc_file not set correctly in /opt/etc/Thermiq_Linux.ini.</span> Should be:\nmail_rc_file  = /etc/msmtprc\n\n";
			echo '<a href="/settings_mail.php">Fix it here</a>';
			/*exec("sudo /bin/sed -i 's:^.*mail_rc_file.*:mail_rc_file  = /etc/msmtprc:' /opt/etc/Thermiq_Linux.ini",$output,$err);
			print_r2( $output);
			print_r2( $err);*/
		}
	}
}
	echo "<hr><br><b>Checking selected COM port, ".$device ." , for answer from ThermIQ</b></br>";

  // This is ugly - TODO: Find a general solution for sake of portability
  if (strstr(php_uname(),'Linux')) {
  	echo "Doing Linux init<br>";
  	exec("$sttypath -F $device clocal cread -parenb -brkint -icrnl -imaxbel -opost -isig -icanon -iexten -echo time 100 min 0 9600");
  	exec("$sttypath -F $device");
  } else {
    // Note: the backticks on the following line will execute the
    // DOS 'mode' command from within PHP
    `mode com1: BAUD=9600 PARITY=N data=8 stop=1 xon=off`;
  }

  $fp = fopen($device,'r+b');
  if (!$fp) {
    echo "Unable to open selected COM port, $device<br>";
    echo "Check that settings in /opt/etc/Thermiq_Linux.ini matches COM-port in device manger<br>";
    echo "Default settings, 9600 8N1 is good but not really a requirement<br>";
	} else {
		stream_set_timeout  ( $fp,3);
		echo "Sending ati, expecting to get version info back";
		fwrite($fp,"ati\r");
		sleep(2);
  	$outstr = '';
		while (!feof($fp)) {
			echo htmlspecialchars(fgets($fp,1024));
		}
		if ($fp) {fclose($fp);}
	}

 $fp = fopen($device,'r+b');
 if (!$fp) {
    echo '<span style="color:red">Unable to open selected COM port, '.$device.'<br>';
    echo 'Check that Settings->Basic Settings->Com Port Name in ThermIQ Webinterface is correct<br></span>';
	  echo "Default settings are 9600 8N1 but does not really matter<br></span>";
    
	} else {
		//stream_set_timeout  ( $fp,3);
		echo "<br>Check Link-mode, 0= Normal mode, 1= Link-mode";
		fwrite($fp,"atl?\r");
		sleep(2);
  	$outstr = '';
		while (!feof($fp)) {
			echo htmlspecialchars(fgets($fp,1024));
		}
		if ($fp) {fclose($fp);}
	}
	
	 $fp = fopen($device,'r+b');
 if (!$fp) {
    echo '<span style="color:red">Unable to open selected COM port, '.$device.'<br>';
    echo 'Check that Settings->Basic Settings->Com Port Name in ThermIQ Webinterface is correct<br></span>';
	  echo "Default settings are 9600 8N1 but does not really matter<br></span>";
    
	} else {
		//stream_set_timeout  ( $fp,3);
			echo "<br>attempting read, expecting something like \"00=1234\" back";

		fwrite($fp,"atr00\r");
		sleep(4);
  	$outstr = '';
		while (!feof($fp)) {
			echo htmlspecialchars(fgets($fp,1024));
		}
		if ($fp) {fclose($fp);}
	}
			

	echo "<hr><br><b>That's all folks. Check the log above for any messages. When all is OK then</b></br>";
	echo "continue <A href=settings.php>here</A> to do initial configuration. Default user=admin, password=manager"
?> 

 </body>
</html>

