<?php
/* SVN FILE: $Id: init.php 434 2013-02-17 13:10:53Z anders $
* Project Name : ThermIQ*
* @version $Revision: 434 $
* @lastrevision $Date: 2013-02-17 14:10:53 +0100 (sön, 17 feb 2013) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2013-02-17 14:10:53 +0100 (sön, 17 feb 2013) $
*/

if (!function_exists('file_exists_incpath' )) {
function file_exists_incpath ($file)
	{ $start=0;
	if (substr($file,0,1)=='/' || substr($file,0,1)=='\\' ) { $start=1;}
	    $corFile=str_replace('/',DIRECTORY_SEPARATOR,subStr($file,$start,1024));	
	    
	    $paths = explode(PATH_SEPARATOR, get_include_path().PATH_SEPARATOR);
	    foreach ($paths as $path) {
	        // Formulate the absolute path
	        $fullpath = $path . DIRECTORY_SEPARATOR . $corFile;
	        // Check it
	        if (file_exists($fullpath)) {
	            return $fullpath;
	           
	        }
	    }
	    return false;
	}
}
if (!function_exists('browser_type' )) {
function browser_type()
{
	$useragent = $_SERVER['HTTP_USER_AGENT'];
	
	if (preg_match('|MSIE ([0-9].[0-9]{1,2})|',$useragent,$matched)) {
	    $browser_version=$matched[1];
	    $browser = 'IE';
	} elseif (preg_match( '|Opera ([0-9].[0-9]{1,2})|',$useragent,$matched)) {
	    $browser_version=$matched[1];
	    $browser = 'Opera';
	} elseif(preg_match('|Firefox/([0-9\.]+)|',$useragent,$matched)) {
	        $browser_version=$matched[1];
	        $browser = 'Firefox';
	} elseif(preg_match('|Safari/([0-9\.]+)|',$useragent,$matched)) {
	        $browser_version=$matched[1];
	        $browser = 'Safari';
	} else {
	        // browser not recognized!
	    $browser_version = 0;
	    $browser= 'other';
	}
	return($browser.":".$browser_version);
}
}

if (strstr(php_uname('s'),'Linux')) {
	if (file_exists('/opt/etc/Thermiq_Linux.ini')) {
		// Default Linux path
		$opt_path='/opt/etc/';
	} else
	if (file_exists('/mnt/sdcard/paw/opt/etc/Thermiq_Linux.ini')) {
		// Android path
		$opt_path='/mnt/sdcard/paw/opt/etc/';
	}
	$settings = parse_ini_file($opt_path.'Thermiq_Linux.ini',TRUE);
}
else if(strstr(php_uname('s'),'Windows')) {
	$opt_path='c:/xampp/opt/etc/';
	$settings = parse_ini_file($opt_path.'Thermiq_Windows.ini',TRUE);	
} else {
	echo "<br><b>Unknown OS:</b> assuming Unix-style paths.</br>";
	echo "Update <webroot>/init.php to correct this</br>";
	$opt_path='/opt/etc/';
	$settings = parse_ini_file($opt_path.'Thermiq_Linux.ini',TRUE);	
}

if (isset($settings['thermiq']['optional_init']) && ($settings['thermiq']['optional_init']<>'')) {

if (!function_exists('ini_merge')) {
function ini_merge ($config_ini, $custom_ini) {
	  foreach ($custom_ini AS $k => $v):
	    if (is_array($v)):
	      $config_ini[$k] = ini_merge($config_ini[$k], $custom_ini[$k]);
	    else:
	      $config_ini[$k] = $v;
	    endif;
	  endforeach;
	  return $config_ini;
	};

	if($newsettings= parse_ini_file($settings['thermiq']['optional_init'],TRUE)) {
		$settings=ini_merge($settings,$newsettings);
	}
}
}



$auth_ok = 0;
$admin = 0;
unset($user);
$pass="";
if (isset($_SERVER['PHP_AUTH_USER'])) {
$user = $_SERVER['PHP_AUTH_USER'];
}
if (isset($_SERVER['PHP_AUTH_PW'])) {
$pass = $_SERVER['PHP_AUTH_PW'];
}
if (isset($user) && isset($pass) && $pass === $settings['passwd'][$user]) {
$auth_ok = 1;
}
if (!$auth_ok) {
 header('WWW-Authenticate: Basic realm="Thermiq Login"');
 header('HTTP/1.0 401 Unauthorized');
 exit;
}
$admin = ($settings['rights'][$user] === 'admin');
$tempdir =($settings['misc']['tempdir']);
    try
    {
			$tempdb = new PDO($settings['database']['temporary']);
    } catch (Exception $e) {
		}
		
    try
    {
			$permdb = new PDO($settings['database']['permanent']);
    } catch (Exception $e) {
		}
$mailnam = $settings['misc']['permdir'] . 'mailargs';
$device = $settings['misc']['com_device'];
$poll_mode=0;

if (isset($settings['misc']['poller_mode'])&& ($settings['misc']['poller_mode']=='IP') && isset($settings['misc']['ip_device']) && ($settings['misc']['ip_device']<>'')) {
	$device=$settings['misc']['ip_device'];
	$poll_mode=1;
}

$ElectrIQ_IP='';
$ElectrIQ_poll=false;
$ElectrIQ_scale=1;
if ( isset($settings['ElectrIQ']['poller_ElectrIQ'])&& isset($settings['ElectrIQ']['ip_device']) && ($settings['ElectrIQ']['ip_device']<>'')) {
	$ElectrIQ_IP=$settings['ElectrIQ']['ip_device'];
	if ( $settings['ElectrIQ']['poller_ElectrIQ'] == '1') $ElectrIQ_poll=true;
	if ( isset($settings['ElectrIQ']['TicksPerWatt'])&& is_numeric($settings['ElectrIQ']['TicksPerWatt'])) $ElectrIQ_scale=$settings['ElectrIQ']['TicksPerWatt']/1000;
}
$php_prepend = ($settings['misc']['php_exec']);
if ($php_prepend<>'') {
	$php_prepend.=' ';
}
$php_prepend .= ($settings['misc']['php_scriptpath']);

$lang=$settings['thermiq']['language'];
	if ($lang=='') {
		$lang=substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
	}
	switch ($lang) {
		case 'sv': case 'se':$lang='sw'; break;
		case 'nb': CASE 'nn':$lang='no'; break;	
	}	
	
	if (($settings['thermiq']['language']<>'')&&($settings['thermiq']['language']<>$lang)) {
		$settings['thermiq']['language']=$lang;
	}
	
if (file_exists($opt_path.'Thermiq_'.$lang.'.ini')||
    file_exists_incpath($opt_path.'Thermiq_'.$lang.'.ini')) {
$ui_string = parse_ini_file($opt_path.'Thermiq_'.$lang.'.ini',TRUE);
} else {
	$ui_string = parse_ini_file($opt_path.'Thermiq_sw.ini',TRUE);
	echo("<br><b>Missing or faulty language file: </b>/opt/etc/Thermiq_".$lang.'.ini</br>');
	echo("You can correct this in ".$opt_path."Thermiq.ini</b></br>");
}

if (isset($settings['thermiq']['hp_type'])) {
	switch(strtolower($settings['thermiq']['hp_type'])) {
		case 'optimumg2':$status_bg_picture='img/OptimumG2.png';
				break;
		case 'diplomat':
                case 'optimum': $status_bg_picture='img/Diplomat.png';
				break;
		default:
			$status_bg_picture='img/OptimumG2.png';
	}
} else $status_bg_picture='img/OptimumG2.png';

$compr_power=1;
if (isset($settings['thermiq']['compressor_power']) && is_numeric($settings['thermiq']['compressor_power'])) {
	$compr_power=$settings['thermiq']['compressor_power'];
}
  $sttypath = "/opt/bin/stty";
?>
