#!/ffp/bin/sh
#/ffp/start/thermiq.sh
# PROVIDE: cronjobs
# REQUIRE: LOGIN

. /ffp/etc/ffp.subr

name="thermiq"
start_cmd="thermiq_start"
stop_cmd="thermiq_stop"
status_cmd="thermiq_status"

thermiq_start()
{
  # Get current jobs without poller, then add poller
  crontab -l | grep -v /usr/sbin/poller  > /tmp/cronjobs
  
  # Job 1 - Start poller and run every minut if interface is there
  if ( `eval /ffp/bin/stty -F /dev/ttyUSB0 clocal cread -parenb -brkint -icrnl -imaxbel -opost -isig -icanon -iexten -echo time 25 min 0 9600` ) ; then
      echo "* * * * * /ffp/thermiq/common/usr/sbin/poller &>/dev/null" >>/tmp/cronjobs
  fi
  
  # Import jobs to service
  crontab /tmp/cronjobs
  echo "Adding ThermIQ to cron jobs"
  rm /tmp/cronjobs
}

thermiq_stop(){
  crontab -l | grep -v /usr/sbin/poller > /tmp/cronjobs
  crontab /tmp/cronjobs
  echo "removing ThermIQ cron job"
  rm /tmp/cronjobs
}

thermiq_status()
{
    crontab -l | grep poller
}

run_rc_command "$1"